(defun lg (d) (* 0.4342944819032518276511289189166 (log d)))
(defun sqr (d) (* d d))
(defun asin (d) (atan d (sqrt (- 1 (* d d)))))
(defun acos (d) (atan (sqrt (- 1 (* d d))) d))
(defun tan (d) (/ (sin d) (cos d)))
(defun ctan (d) (/ (cos d) (sin d)))
(defun sin2 (d) (sin (* d (/ pi 180))))
(defun cos2 (d) (cos (* d (/ pi 180))))
(defun tan2 (d / r) (setq r (* d (/ pi 180))) (/ (sin r) (cos r)))
(setq ^   expt
      inc 1+
      dec 1-
      ln  log
      mod rem)
 
(defun split-list  (lst n / l1 l2 i)
  (setq i (length lst))
  (foreach item  (reverse lst)
    (setq i (1- i))
    (if (< i n)
      (setq l1 (cons item l1))
      (setq l2 (cons item l2))))
  (cons l1 l2))
 
(defun infix->prefix  (infix-expression / str->lst inf->pre-help placeholders operators functions placeholder-revert)
  (vl-load-com)
  (setq operators '(+ - * / ^)
        functions '(ABS ACOS ASIN ATAN COS COS2 CTAN DEC EXP FIX FLOAT INC LG LN LOG LOGAND LOGIOR MAX MIN REM SIN SIN2
                    SQR SQRT TAN TAN2))
 
  ;; Derived from format1 by HyflyingBird
  (defun str->lst  (str / char funs lastfun lst tmp lastchar)
    (setq lastfun "(")
    (setq funs '("+" "-" "*" "/" "^" "%" "(" ")" " "))
    (setq tmp "")
    (while (/= str "")
      (setq char (substr str 1 1)
            str  (substr str 2))
      (if (and (member char funs)
               (not (and lastfun (/= lastfun ")") (= char "-")))
               (not (and lastchar (or (= char "-") (= char "+")))))
        (progn (setq lst      (vl-list* char tmp lst)
                     tmp      ""
                     lastfun  char
                     lastchar nil)
               (princ))
        (progn (setq tmp (strcat tmp char)) (setq lastfun nil) (setq lastchar (= char "e")) (princ))))
    (read (vl-princ-to-string (vl-remove "" (vl-remove " " (reverse (cons tmp lst)))))))
 
  ;; Helper to recursively prefix the infix list
  (defun inf->pre-help  (infix-expression / split)
    (cond ((not (listp infix-expression)) infix-expression)
          ((= (length infix-expression) 1) (inf->pre-help (car infix-expression)))
          ((member (car infix-expression) functions)
           (setq split        (list (read (strcat "$placeholder" (itoa (length placeholders))))
                                    (car infix-expression)
                                    (cadr infix-expression))
                 placeholders (cons split placeholders))
           (inf->pre-help (cons (car split) (cddr infix-expression))))
          ((> (setq split (car (vl-remove-if
                                 'null
                                 (mapcar (function (lambda (item) (vl-position item infix-expression))) operators))))
              0)
           (list (cadr (setq split (split-list infix-expression split)))
                 (inf->pre-help (car split))
                 (inf->pre-help (cddr split))))
          (t (mapcar (function inf->pre-help) infix-expression))))
 
  ;; Helper to add back the placeholders
  (defun placeholder-revert  (prefix-expression / place tmp)
    (mapcar (function (lambda (item)
                        (cond ((listp item) (placeholder-revert item))
                              ((setq place (assoc item placeholders))
                               (setq tmp (placeholder-revert (inf->pre-help (caddr place))))
                               (if (member (car tmp) (append operators functions))
                                 (cons (cadr place) (list tmp))
                                 (cons (cadr place) tmp)))
                              (t item))))
            (if (listp prefix-expression) prefix-expression (list prefix-expression))))
 
  (if (and (setq placeholders (placeholder-revert (inf->pre-help (if (listp infix-expression)
                                                                   infix-expression
                                                                   (str->lst infix-expression)))))
           (<= (length placeholders) 1)
           (listp (car placeholders)))
    (car placeholders)
    placeholders))